#ifndef PICTUREVIEWPLUGIN_H
#define PICTUREVIEWPLUGIN_H

//  PVD -, v1.0

//    : UTF-8.


//   PVD,    .
//       pvdInit   .
#define PVD_CURRENT_INTERFACE_VERSION 1


//   
#define PVD_IIF_ANIMATED 1


//       
#define PVD_IDF_READONLY 1


// pvdInfoPlugin -   
struct pvdInfoPlugin
{
	UINT32 Priority;          //  ;  0,        
	const char *pName;        //  
	const char *pVersion;     //  
	const char *pComments;    //   :   ,   , ...
};

// pvdInfoImage -   
struct pvdInfoImage
{
	UINT32 nPages;            //   
	UINT32 Flags;             //  : PVD_IIF_ANIMATED
	const char *pFormatName;  //   
	const char *pCompression; //  
	const char *pComments;    //    
};

// pvdInfoPage -    
struct pvdInfoPage
{
	UINT32 lWidth;            //  
	UINT32 lHeight;           //  
	UINT32 nBPP;              //     (   -    )
	UINT32 lFrameTime;        //    -      ;
	                          //  -  
};

// pvdInfoDecode -    
struct pvdInfoDecode
{
	BYTE   *pImage;            //       RGB
	UINT32 *pPalette;          //    ,    8     
	UINT32 Flags;              //  : PVD_IDF_READONLY
	UINT32 nBPP;               //       
	UINT32 nColorsUsed;        //     ;  0,     
	INT32  lImagePitch;        //  -      ;
	                           //   -    ,  -  
};


// pvdDecodeCallback - ,      pvdPageDecode
//  :   pvdPageDecode
//    ,    ,      .
//  :
//   pDecodeCallbackContext - ,    pvdPageDecode
//   iStep  -     (  0  nSteps - 1)
//   nSteps -    
//   : TRUE -  ; FALSE -   
typedef BOOL (__stdcall *pvdDecodeCallback)(void *pDecodeCallbackContext, UINT32 iStep, UINT32 nSteps);


// pvdInit -  
//  :   -    
//   :   
//         ,   pvdExit    .
//       -1.   1.    PVD_CURRENT_INTERFACE_VERSION
//   0 -  / .
UINT32 __stdcall pvdInit(void);

// pvdExit -    
//  :   -    
void __stdcall pvdExit(void);

// pvdPluginInfo -    
//  :  
//  :
//   pPluginInfo -          
void __stdcall pvdPluginInfo(pvdInfoPlugin *pPluginInfo);

// pvdFileOpen -  :  ,     ,      
//  :   
//  :
//   pFileName   -   
//   lFileSize   -     .  0,   ,    pBuf 
//                           pvdFileClose.
//   pBuf        - ,    
//   lBuf        -   pBuf  .     16 .
//   pImageInfo  -          ,     
//   ppContext   -   .        -  ,
//                            .   
//                 ,            ,
//                    ,      .
//   : TRUE -      ;  - FALSE
BOOL __stdcall pvdFileOpen(const char *pFileName, INT64 lFileSize, const BYTE *pBuf, UINT32 lBuf, pvdInfoImage *pImageInfo, void **ppContext);

// pvdPageInfo -    
//  :   pvdFileOpen  pvdFileClose
//  :
//   pContext    - ,    pvdFileOpen
//   iPage       -    (   0)
//   pPageInfo   -           
//   : TRUE -   ;  - FALSE
BOOL __stdcall pvdPageInfo(void *pContext, UINT32 iPage, pvdInfoPage *pPageInfo);

// pvdPageDecode -   
//  :   pvdFileOpen  pvdFileClose
//  :
//   pContext       - ,    pvdFileOpen
//   iPage          -    (   0)
//   pDecodeInfo    -           
//   DecodeCallback -   ,         
//                    ; NULL,     
//   pDecodeCallbackContext - ,   DecodeCallback
//   : TRUE -   ;  - FALSE
BOOL __stdcall pvdPageDecode(void *pContext, UINT32 iPage, pvdInfoDecode *pDecodeInfo, pvdDecodeCallback DecodeCallback, void *pDecodeCallbackContext);

// pvdPageFree -   
//  :   pvdPageDecode,      
//  :
//   pContext    - ,    pvdFileOpen
//   pDecodeInfo -        ,   pvdPageDecode
void __stdcall pvdPageFree(void *pContext, pvdInfoDecode *pDecodeInfo);

// pvdFileClose -  
//  :   pvdFileOpen,     
//  :
//   pContext    - ,    pvdFileOpen
void __stdcall pvdFileClose(void *pContext);

#endif
