#ifndef __CRT__
#define __CRT__

#include <windows.h>

#ifndef _DEBUG

#define heapNEW GetProcessHeap()

void *malloc(size_t size)
{
  return HeapAlloc(heapNEW, HEAP_ZERO_MEMORY, size);
}
/*void *realloc(void *block, size_t size)
{
  if (block)
    return HeapReAlloc(heapNEW,HEAP_ZERO_MEMORY,block,size);
  else
    return HeapAlloc(heapNEW,HEAP_ZERO_MEMORY, size);
} */
void free(void *block)
{
  HeapFree(heapNEW,0,block);
}

#ifdef __cplusplus
void * operator new(size_t size)
{
  return HeapAlloc(heapNEW, HEAP_ZERO_MEMORY, size);
}

void operator delete(void *block)
{
  HeapFree(heapNEW,0,block);
}
#endif
// some crazy stuff to allow linking witout CRT
extern "C" void __declspec(naked) __cdecl _chkstk()
{

#ifndef _PAGESIZE_
#define _PAGESIZE_ 1000h
#endif

__asm {

        push ecx           // save ecx
        cmp     eax, _PAGESIZE_         // more than one page requested?
        lea     ecx, [esp] + 8          // compute new stack pointer in ecx
                                        // correct for return address and
                                        // saved ecx
        jb      short lastpage          // no
probepages:
        sub     ecx, _PAGESIZE_         // yes, move down a page
        sub     eax, _PAGESIZE_         // adjust request and...
        test    dword ptr [ecx], eax    // ...probe it
        cmp     eax, _PAGESIZE_         // more than one page requested?
        jae     short probepages        // no


lastpage:

        sub     ecx, eax                // move stack down by eax
        mov     eax, esp                // save current tos and do a...

        test    dword ptr [ecx], eax    // ...probe in case a page was crossed

        mov     esp, ecx                // set the new stack pointer

        mov     ecx, dword ptr [eax]    // recover ecx
        mov     eax, dword ptr [eax + 4]// recover return address

        push    eax                     // prepare return address
                                        // ...probe in case a page was crossed
        ret
    }
}
#endif
#endif